--
-- $Id: user-begin.vhdl,v 1.2 2009-08-25 06:29:08 sand Exp $
--

library expect;
use expect.types.all;
use expect.procedures.all;

entity user is
        port(
		pc1_power_button: out boolean;
		pc1_cdrom: out cstring;
		pc1_key: out boolean_array(0 to 127);
		pc1_screen_shot: out boolean;
		pc1_rec : out boolean;
		pc1_opt_screen: in opt_rgb;

		pc2_power_button: out boolean;
		pc2_cdrom: out cstring;
		pc2_key: out boolean_array(0 to 127);
		pc2_screen_shot: out boolean;
		pc2_rec : out boolean;
		pc2_opt_screen: in opt_rgb
	);
end user;

architecture behaviour of user is
	signal pc1_int_asc_text0 : cstring;
	signal pc1_int_asc_text1 : cstring;
	signal pc1_int_asc_text2 : cstring;
	signal pc1_int_asc_text3 : cstring;
	signal pc1_int_asc_text0_state : boolean;
	signal pc1_int_asc_text1_state : boolean;
	signal pc1_int_asc_text2_state : boolean;
	signal pc1_int_asc_text3_state : boolean;
	signal pc1_int_slot0 : match;
	signal pc1_int_slot1 : match;
	signal pc1_int_slot2 : match;
	signal pc1_int_slot3 : match;
	signal pc1_int_slot4 : match;
	signal pc1_int_slot5 : match;
	signal pc1_int_slot6 : match;
	signal pc1_int_slot7 : match;
	signal pc1_int_slot8 : match;
	signal pc1_int_slot9 : match;
	signal pc1_int_slot10 : match;
	signal pc1_int_slot11 : match;
	signal pc1_int_slot12 : match;
	signal pc1_int_slot13 : match;
	signal pc1_int_slot14 : match;
	signal pc1_int_slot15 : match;
	signal pc1_int_text0 : cstring;
	signal pc1_int_text1 : cstring;
	signal pc1_int_text2 : cstring;
	signal pc1_int_text3 : cstring;
	signal pc1_int_pattern_rectangle0 : cstring;
	signal pc1_int_pattern_rectangle1 : cstring;
	signal pc1_int_pattern_rectangle2 : cstring;
	signal pc1_int_pattern_rectangle3 : cstring;

	signal pc2_int_asc_text0 : cstring;
	signal pc2_int_asc_text1 : cstring;
	signal pc2_int_asc_text2 : cstring;
	signal pc2_int_asc_text3 : cstring;
	signal pc2_int_asc_text0_state : boolean;
	signal pc2_int_asc_text1_state : boolean;
	signal pc2_int_asc_text2_state : boolean;
	signal pc2_int_asc_text3_state : boolean;
	signal pc2_int_slot0 : match;
	signal pc2_int_slot1 : match;
	signal pc2_int_slot2 : match;
	signal pc2_int_slot3 : match;
	signal pc2_int_slot4 : match;
	signal pc2_int_slot5 : match;
	signal pc2_int_slot6 : match;
	signal pc2_int_slot7 : match;
	signal pc2_int_slot8 : match;
	signal pc2_int_slot9 : match;
	signal pc2_int_slot10 : match;
	signal pc2_int_slot11 : match;
	signal pc2_int_slot12 : match;
	signal pc2_int_slot13 : match;
	signal pc2_int_slot14 : match;
	signal pc2_int_slot15 : match;
	signal pc2_int_text0 : cstring;
	signal pc2_int_text1 : cstring;
	signal pc2_int_text2 : cstring;
	signal pc2_int_text3 : cstring;
	signal pc2_int_pattern_rectangle0 : cstring;
	signal pc2_int_pattern_rectangle1 : cstring;
	signal pc2_int_pattern_rectangle2 : cstring;
	signal pc2_int_pattern_rectangle3 : cstring;

	signal fault : integer;

begin
	pc1_patternm: patternm
		port map (
			video => pc1_opt_screen,
			asc_text0 => pc1_int_asc_text0,
			asc_text0_state => pc1_int_asc_text0_state,
			asc_text1 => pc1_int_asc_text1,
			asc_text1_state => pc1_int_asc_text1_state,
			asc_text2 => pc1_int_asc_text2,
			asc_text2_state => pc1_int_asc_text2_state,
			asc_text3 => pc1_int_asc_text3,
			asc_text3_state => pc1_int_asc_text3_state,
			slot0 => pc1_int_slot0,
			slot1 => pc1_int_slot1,
			slot2 => pc1_int_slot2,
			slot3 => pc1_int_slot3,
			slot4 => pc1_int_slot4,
			slot5 => pc1_int_slot5,
			slot6 => pc1_int_slot6,
			slot7 => pc1_int_slot7,
			slot8 => pc1_int_slot8,
			slot9 => pc1_int_slot9,
			slot10 => pc1_int_slot10,
			slot11 => pc1_int_slot11,
			slot12 => pc1_int_slot12,
			slot13 => pc1_int_slot13,
			slot14 => pc1_int_slot14,
			slot15 => pc1_int_slot15,
			text0 => pc1_int_text0,
			text1 => pc1_int_text1,
			text2 => pc1_int_text2,
			text3 => pc1_int_text3,
			pattern_rectangle0 => pc1_int_pattern_rectangle0,
			pattern_rectangle1 => pc1_int_pattern_rectangle1,
			pattern_rectangle2 => pc1_int_pattern_rectangle2,
			pattern_rectangle3 => pc1_int_pattern_rectangle3
		);
	pc2_patternm: patternm
		port map (
			video => pc2_opt_screen,
			asc_text0 => pc2_int_asc_text0,
			asc_text0_state => pc2_int_asc_text0_state,
			asc_text1 => pc2_int_asc_text1,
			asc_text1_state => pc2_int_asc_text1_state,
			asc_text2 => pc2_int_asc_text2,
			asc_text2_state => pc2_int_asc_text2_state,
			asc_text3 => pc2_int_asc_text3,
			asc_text3_state => pc2_int_asc_text3_state,
			slot0 => pc2_int_slot0,
			slot1 => pc2_int_slot1,
			slot2 => pc2_int_slot2,
			slot3 => pc2_int_slot3,
			slot4 => pc2_int_slot4,
			slot5 => pc2_int_slot5,
			slot6 => pc2_int_slot6,
			slot7 => pc2_int_slot7,
			slot8 => pc2_int_slot8,
			slot9 => pc2_int_slot9,
			slot10 => pc2_int_slot10,
			slot11 => pc2_int_slot11,
			slot12 => pc2_int_slot12,
			slot13 => pc2_int_slot13,
			slot14 => pc2_int_slot14,
			slot15 => pc2_int_slot15,
			text0 => pc2_int_text0,
			text1 => pc2_int_text1,
			text2 => pc2_int_text2,
			text3 => pc2_int_text3,
			pattern_rectangle0 => pc2_int_pattern_rectangle0,
			pattern_rectangle1 => pc2_int_pattern_rectangle1,
			pattern_rectangle2 => pc2_int_pattern_rectangle2,
			pattern_rectangle3 => pc2_int_pattern_rectangle3
		);
	installation_script: process
	begin
